#ifndef MY_CALLBACK_TYPE
#define MY_CALLBACK_TYPE

#include "DFITCL2Api.h"
#include <iostream>
using namespace DFITC_L2;

class my_callback_t : public DFITC_L2::DFITCL2Spi{
public:
    my_callback_t() { }
    ~my_callback_t() { }
    void OnConnected();
    void OnDisconnected(int pReason);
    void OnRspUserLogin(struct ErrorRtnField * pErrorField);
    void OnRspUserLogout(struct ErrorRtnField * pErrorField);
    void OnRspSubscribeMarketData(struct ErrorRtnField * pErrorField);
    void OnRspUnSubscribeMarketData(ErrorRtnField * pErrorField);
    void OnRspSubscribeAll(struct ErrorRtnField * pErrorField);
    void OnRspUnSubscribeAll(struct ErrorRtnField * pErrorField);
    void OnRspModifyPassword(struct ErrorRtnField * pErrorField);
    void OnHeartBeatLost();

    void OnBestAndDeep(MDBestAndDeep * const pQuote, UINT4 SequenceNo);
    void OnArbi(MDBestAndDeep * const pQuote, UINT4 SequenceNo);
    void OnTenEntrust(MDTenEntrust * const pQuote, UINT4 SequenceNo);
    void OnRealtime(MDRealTimePrice * const pQuote, UINT4 SequenceNo);
    void OnOrderStatistic(MDOrderStatistic * const pQuote, UINT4 SequenceNo);
    void OnMarchPrice(MDMarchPriceQty * const pQuote, UINT4 SequenceNo);
protected:
	DFITC_L2::DFITCL2Api *md_pApi;
};

#endif

